VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOPT"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''
' ARCADE QUAKE LAUNCHER
' :  . , pauk.vortex@gmail.com
'     
''''''''''''''''''''''''''''''''''''''''

''''''''''''''''''''''''''''''''''''''''
' 
''''''''''''''''''''''''''''''''''''''''

'   INI
Private Declare Function GetPrivateProfileStringByKeyName Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpszKey As String, ByVal lpszDefault As String, ByVal lpszReturnBuffer As String, ByVal cchReturnBuffer As Long, ByVal lpszFile As String) As Long
Private Declare Function WritePrivateProfileStringByKeyName Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lplFileName As String) As Long
Private Declare Function WritePrivateProfileStringToDeleteKey Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Long, ByVal lplFileName As String) As Long
Private Const INI_READ_BUFF As Long = 1024
Private INI_FILENAME As String

'   
Private Const MAX_LISTS = 32
Private Const MAX_LISTS_ITEMS = 32
Private Type ListData
    Names(MAX_LISTS_ITEMS) As String
    Values(MAX_LISTS_ITEMS) As String
    LastIndex As Integer
End Type
Private ListsData(MAX_LISTS) As ListData
Private Lists(MAX_LISTS) As String
Private NumLists As Integer

'   
Private Const MAX_OPTIONS = 1024
Private Type OptionType
    Key As String
    Group As String
    Value As String
    DefValue As String
    ListIndex As Integer
End Type
Private Options(MAX_OPTIONS) As OptionType
Private NumOptions As Integer

''''''''''''''''''''''''''''''''''''''''
'    INI
''''''''''''''''''''''''''''''''''''''''

'  -1      Long Integer   
Private Function IniAdd(tSection As String, tKey As String, tValue As String) As Long
    If Len(strKey) > READ_BUFF Or Len(strValue) > READ_BUFF Then
        MsgBox "       " & INI_READ_BUFF & "!", vbCritical
        IniAdd = -1
        Exit Function
    End If
    IniAdd = WritePrivateProfileStringByKeyName(tSection, tKey, tValue, INI_FILENAME)
End Function

Public Function IniRead(ByVal tSection As String, ByVal tKey As String) As String
    Dim tValue As String
    Dim tRetLen As Long

    tValue = String(INI_READ_BUFF + 1, Space(1))
    tRetLen = GetPrivateProfileStringByKeyName(tSection, tKey, "", tValue, INI_READ_BUFF, INI_FILENAME)
    IniRead = Left(tValue, tRetLen)
End Function

Public Function IniDelete(tSection As String, Optional tKey As String) As Long
    If strKey = "" Then
        IniDelete = WritePrivateProfileStringToDeleteKey(tSection, vbNullString, 0, INI_FILENAME)
    Else
        IniDelete = WritePrivateProfileStringToDeleteKey(tSection, tKey, 0, INI_FILENAME)
    End If
End Function

Public Sub IniSetFile(tFilePath As String)
    INI_FILENAME = tFilePath
End Sub

''''''''''''''''''''''''''''''''''''''''
'    
''''''''''''''''''''''''''''''''''''''''

Private Function ListGetIndex(tListName As String) As Integer
    Dim tPos As Integer
    For tPos = 0 To UBound(Lists)
        If (Lists(tPos) = tListName) Then
            ListGetIndex = tPos
            Exit Function
        End If
    Next tPos
    ListGetIndex = -1
End Function

Public Sub ListAdd(tName As String, tNameArray As Variant, tValueArray As Variant)
    Dim tPos As Integer
    Lists(NumLists) = tName
    ListsData(NumLists).LastIndex = UBound(tNameArray)
    For tPos = 0 To UBound(tNameArray)
        ListsData(NumLists).Names(tPos) = tNameArray(tPos) & ""
        ListsData(NumLists).Values(tPos) = tValueArray(tPos) & ""
    Next tPos
    NumLists = NumLists + 1
End Sub

Public Function ListGetCount(tListName As String) As Integer
    Dim tIndex As Integer
    
    tIndex = ListGetIndex(tListName)
    If (tIndex < 0) Then
        ListGetCount = -1
        Exit Function
    End If
    
    ListGetCount = ListsData(tIndex).LastIndex + 1
End Function

Public Function ListGetNames(tListName As String) As Variant()
    Dim tIndex As Integer
    Dim tPos As Integer
    Dim tVariantList(MAX_LISTS_ITEMS) As Variant

    tIndex = ListGetIndex(tListName)
    If (tIndex < 0) Then
        ListGetNames = Array()
        Exit Function
    End If
    For tPos = 0 To ListsData(tIndex).LastIndex
        tVariantList(tPos) = ListsData(tIndex).Names(tPos)
    Next tPos
    ListGetNames = tVariantList
End Function

Public Function ListGetValues(tListName As String) As Variant()
    Dim tIndex As Integer
    Dim tPos As Integer
    Dim tVariantList(MAX_LISTS_ITEMS) As Variant
    
    tIndex = ListGetIndex(tListName)
    If (tIndex < 0) Then
        ListGetValues = Array()
        Exit Function
    End If
    For tPos = 0 To ListsData(tIndex).LastIndex
        tVariantList(tPos) = ListsData(tIndex).Values(tPos)
    Next tPos
    ListGetValues = tVariantList
End Function

''''''''''''''''''''''''''''''''''''''''
'    
''''''''''''''''''''''''''''''''''''''''

'   
Private Function OptionGetIndex(tKey As String) As Integer
    Dim tPos As Integer
    For tPos = 0 To UBound(Options)
        If (Options(tPos).Key = tKey) Then
            OptionGetIndex = tPos
            Exit Function
        End If
    Next tPos
    OptionGetIndex = -1
End Function

'     
' tMode:
'   "r" -   
'   "w" -   
'   "rd" -   
'   "sd" -    
'   "wd" -    
Private Function DoOption(tKey As String, tMode As String, Optional tSetValue As String = "") As String
    Dim tIndex As Integer
    
    tIndex = OptionGetIndex(tKey)
    If (tIndex < 0) Then
        Exit Function
    End If
    Select Case tMode
        Case "r"
            DoOption = Options(tIndex).Value
        Case "w"
            Options(tIndex).Value = tSetValue
        Case "rd"
            DoOption = Options(tIndex).DefValue
        Case "sd"
            Options(tIndex).Value = Options(tIndex).DefValue
        Case "wd"
            Options(tIndex).DefValue = tSetValue
        Case Else
    End Select
End Function

'      
Public Sub LoadAll(tFilePath As String)
    Dim tPos As Integer
    'MsgBox "LoadAll"
    IniSetFile tFilePath
    For tPos = 0 To NumOptions - 1 Step 1
        Options(tPos).Value = IniRead(Options(tPos).Group, Options(tPos).Key)
        If (Options(tPos).Value = "") Then
            Options(tPos).Value = Options(tPos).DefValue
        End If
    Next tPos
End Sub

'      
Public Sub LoadGroup(tFilePath As String, tGroupName As String)
    Dim tPos As Integer
    IniSetFile tFilePath
    For tPos = 0 To NumOptions - 1 Step 1
        If (Options(tPos).Group = tGroupName) Then
            Options(tPos).Value = IniRead(Options(tPos).Group, Options(tPos).Key)
            If (Options(tPos).Value = "") Then
                Options(tPos).Value = Options(tPos).DefValue
            End If
        End If
    Next tPos
End Sub

'      
Public Sub SaveAll(tFilePath As String)
    Dim tPos As Integer
    IniSetFile tFilePath
    For tPos = 0 To NumOptions - 1 Step 1
        'MsgBox "Save: " & Options(tPos).Key & " = " & Options(tPos).Value
        IniAdd Options(tPos).Group, Options(tPos).Key, Options(tPos).Value
    Next tPos
End Sub

'      
Public Sub SaveGroup(tFilePath As String, tGroupName As String)
    Dim tPos As Integer
    IniSetFile tFilePath
    For tPos = 0 To NumOptions - 1 Step 1
        If (Options(tPos).Group = tGroupName) Then
            'MsgBox "Save: " & Options(tPos).Key & " = " & Options(tPos).Value
            IniAdd Options(tPos).Group, Options(tPos).Key, Options(tPos).Value
        End If
    Next tPos
End Sub

'     
Public Sub ResetAll()
    'MsgBox "ResetAll"
    For tPos = 0 To NumOptions - 1 Step 1
        Options(tPos).Value = Options(tPos).DefValue
    Next tPos
End Sub

'       
Public Sub ResetGroup(tGroupName As String)
    For tPos = 0 To NumOptions - 1 Step 1
        If (Options(tPos).Group = tGroupName) Then
            Options(tPos).Value = Options(tPos).DefValue
        End If
    Next tPos
End Sub

'   
Property Get Count()
    Count = NumOptions
End Property

'    
Public Sub Add(tGroup As String, tKey As String, tDefValue As String)
    If (NumOptions >= MAX_OPTIONS) Then
        MsgBox "Ran out of free option slots"
        Exit Sub
    End If
    Options(NumOptions).Key = tKey
    Options(NumOptions).Group = tGroup
    Options(NumOptions).Value = tDefValue
    Options(NumOptions).DefValue = tDefValue
    Options(NumOptions).ListIndex = ListGetIndex(tKey)
    NumOptions = NumOptions + 1
End Sub

'    
Public Function GetString(tKey As String) As String
    GetString = DoOption(tKey, "r")
End Function

'    Bool
Public Function GetBoolean(tKey As String) As Integer
    Dim tValue As String
    tValue = GetString(tKey)
    If (tValue = "1") Then
        GetBoolean = True
    Else
        GetBoolean = False
    End If
End Function

'     - ( -    )
Public Function GetRadio(tKey As String, tMatch As String) As Boolean
    Dim tValue As String
  
    tValue = GetString(tKey)
    If (tValue = tMatch) Then
        GetRadio = True
    Else
        GetRadio = False
    End If
End Function

'     
Public Function GetCheck(tKey As String) As Integer
    Dim tValue As String
    tValue = GetString(tKey)
    If (tValue = "1") Then
        GetCheck = 1
    ElseIf (tValue = "2") Then
        GetCheck = 2
    Else
        GetCheck = 0
    End If
End Function

'         
Public Function GetListIndex(tKey As String) As Integer
    Dim tValue As String
    Dim tIndex As Integer
    Dim tPos As Integer

    tValue = GetString(tKey)
    tIndex = ListGetIndex(tKey)
    If (tIndex < 0) Then
        GetListIndex = -1
        Exit Function
    End If
    For tPos = 0 To ListsData(tIndex).LastIndex
        If (ListsData(tIndex).Values(tPos) = tValue) Then
            GetListIndex = tPos
            Exit Function
        End If
    Next tPos
    GetListIndex = -1
End Function

'  
Public Sub Reset(tKey As String)
    DoOption tKey, "sd"
End Sub

'     
Public Sub SetString(tKey As String, tValue As String)
    DoOption tKey, "w", tValue
End Sub

'     Bool
Public Sub SetBoolean(tKey As String, tValue As Boolean)
    If (tValue = True) Then
        SetString tKey, "1"
    Else
        SetString tKey, "0"
    End If
End Sub

'       - ( -    )
Public Sub SetRadio(tKey As String, tValue As Boolean, tMatch As String)
    If (tValue = True) Then
        SetString tKey, tMatch
    End If
End Sub

'       
Public Sub SetCheck(tKey As String, tValue As Integer)
    If (tValue = 1) Then
        SetString tKey, "1"
    ElseIf (tValue = 2) Then
        SetString tKey, "2"
    Else
        SetString tKey, "0"
    End If
End Sub

'      
Public Sub SetListIndex(tKey As String, tValueListIndex As Integer)
    Dim tOptionIndex As Integer
    Dim tListIndex As Integer
    
    tOptionIndex = OptionGetIndex(tKey)
    If (tOptionIndex < 0) Then
        Exit Sub
    End If
    tListIndex = Options(tOptionIndex).ListIndex
    If (tListIndex < 0) Then
        Exit Sub
    End If
    If (tValueListIndex < 0 Or tValueListIndex > ListsData(tListIndex).LastIndex) Then
        SetString tKey, ListsData(tListIndex).Values(0)
    Else
        SetString tKey, ListsData(tListIndex).Values(tValueListIndex)
    End If
End Sub

